﻿namespace OsuLazerDllPatcher.Loggining;

public enum StepType
{
    Patch,
    Save,
    Error
}

public class StepByStepLogger
{
    public string? CurrentTask { get; set; }
    
    
    public void Step(string task, StepType type = StepType.Patch)
    {
        switch (type)
        {
            case StepType.Patch:
                Console.ForegroundColor = ConsoleColor.Green;
                break;
            case StepType.Save:
                Console.ForegroundColor = ConsoleColor.Yellow;
                break;
            case StepType.Error:
                Console.ForegroundColor= ConsoleColor.Red;
                break;
        }
        
        CurrentTask = task;
        Console.Write($"{type.ToString()}: {task}"); 
    }

    public void DoneAndNewTask(string task, StepType type = StepType.Patch)
    {
        Done();
        Step(task, type);
    }
    
    public void Done()
    {
        Console.ForegroundColor = ConsoleColor.White;
        Console.Write($" => Done\n");
    }
    
    public void Warning(string text)
    {
        Console.ForegroundColor = ConsoleColor.Yellow;
        Console.Write($"Warning: {text}\n");
    }
    
}