﻿using System.Runtime.InteropServices;
using dnlib.DotNet;
using OsuLazerDllPatcher.Loggining;


var defaultLazerPath = Environment.ExpandEnvironmentVariables(@"%LOCALAPPDATA%\osulazer");

if (!Directory.Exists(defaultLazerPath) && args.Length < 1 || !RuntimeInformation.IsOSPlatform(OSPlatform.Windows) && args.Length < 1)
{
    Console.WriteLine("Please, drag & drop osu.Game.dll file.");
    Environment.Exit(1);
}
var logger = new StepByStepLogger();


var osuPath = args.Length < 1 ? Directory.GetDirectories(defaultLazerPath).Last(f => f.Contains("app-")) : Path.GetDirectoryName(args[0]);
var osuResourcesPath = Path.Join(args.Length < 1
    ? Path.Join(osuPath, "osu.Game.Resources.dll")
    : Path.Join(Path.GetDirectoryName(args[0]), "osu.Game.Resources.dll"));


var osuPathDll = Path.Join(args.Length < 1 ? Path.Join(osuPath, "osu.Game.dll") : args[0]);

File.Copy(osuPathDll, osuPathDll + ".bak", true);

var modCtx = ModuleDef.CreateModuleContext();
var module = ModuleDefMD.Load(osuPathDll + ".bak", modCtx);

var typeDef = module.Find("osu.Game.Online.ProductionEndpointConfiguration", false);

var constructor = typeDef.FindConstructors().ElementAt(0);

var hostField = constructor.Body.Instructions[4];
var spectatorField = constructor.Body.Instructions[17];
var multiField = constructor.Body.Instructions[20];
logger.Step("Hosts field");
spectatorField.Operand = "https://lazer.dhcpcd.xyz/spectator";
multiField.Operand = "https://lazer.dhcpcd.xyz/multiplayer";
hostField.Operand = "https://lazer.dhcpcd.xyz";

logger.DoneAndNewTask("Version");
var gameBaseDef = module.Find("osu.Game.OsuGameBase", false);
var versionField = gameBaseDef.FindMethod("get_Version").Body.Instructions[14];
versionField.Operand = "{0}.{1}.{2}-osu!cstellia";

logger.DoneAndNewTask($"{osuPathDll}", StepType.Save);
module.Write(osuPathDll);

//Patching resources
logger.DoneAndNewTask("Flags");

var osuResourcesPathDll = ModuleDefMD.Load($"{osuResourcesPath}", ModuleDef.CreateModuleContext());
var resourceFlagRu =
    osuResourcesPathDll.Resources.FirstOrDefault(r => r.Name == "osu.Game.Resources.Textures.Flags.RU.png");
var resourceFlagBY =
    osuResourcesPathDll.Resources.FirstOrDefault(r => r.Name == "osu.Game.Resources.Textures.Flags.BY.png");

osuResourcesPathDll.Resources.Remove(resourceFlagRu);
osuResourcesPathDll.Resources.Remove(resourceFlagBY);
var noWarFlagRu =  await (await new HttpClient().GetAsync("https://media.discordapp.net/attachments/959162445258162236/959468863257473034/Group_1.png")).Content.ReadAsByteArrayAsync();
var noWarFlagBy =  await (await new HttpClient().GetAsync("https://media.discordapp.net/attachments/959162445258162236/959473102121730100/Group_1.png")).Content.ReadAsByteArrayAsync();
osuResourcesPathDll.Resources.Add(new EmbeddedResource("osu.Game.Resources.Textures.Flags.RU.png", noWarFlagRu, ManifestResourceAttributes.Public));
osuResourcesPathDll.Resources.Add(new EmbeddedResource("osu.Game.Resources.Textures.Flags.BY.png", noWarFlagBy, ManifestResourceAttributes.Public));


logger.DoneAndNewTask($"{osuResourcesPath}.bak", StepType.Save);
osuResourcesPathDll.Write(osuResourcesPath + ".bak");

try
{
    File.Copy(osuResourcesPath + ".bak", osuResourcesPath, true);
}
catch
{
    //ignored
}

logger.Done();

Console.Write(new String('=', Console.WindowWidth));
Console.WriteLine("Done!~");
Console.WriteLine($"osu!lazer location: {osuPath}");
Console.WriteLine($"To reset client to bancho, replace osu.Game.dll with osu.Game.dll.bak, also replace osu.Game.Resources.dll with osu.Game.Resources.dll.bak");
Console.ReadLine();